import openpyxl
from openpyxl.styles import PatternFill, Font
import datetime
import get_Article_Features

import createFeatures
import helpers

testlist = ((3, 5, [1, 0], "Medium1", "Titel1", "Link1"),(5, 2, [0, 0], "Medium2", "Titel2", "Link2"),(1, 3, [1, 1], "Medium3", "Titel3", "Link3"))
csv = "./positive_artikel_glueck.csv"

#"./website_downloads_cleaned_klein.csv"
# "/home/nina/BigDataProject/article_dump/article_dump/website_downloads_2017-11-10.csv-cleaned.csv"

# [[-0.8032128514056224], ['negative'], [0, 0], 'www.bild.de', 'Rodel-Weltcup in Altenberg - Sturz-Drama um Aileen Frisch  -\n\tDresden -\n\tBild.de', 'http://www.bild.de/regional/dresden/rennrodeln/sturz-drama-um-aileen-frisch-54054516.bild.html?wtmc=ob.feed']

now = datetime.datetime.now()
time = datetime.datetime.now().time()
date = str(now.year) + "-" + str(now.month) + "-" + str(now.day) + "-" + str(time.hour) + "-" + str(time.minute)

redFill = PatternFill(start_color='FF0000',
                   end_color='FF0000',
                   fill_type='solid')

yellowFill = PatternFill(start_color='FFFF00',
                   end_color='FFFF0000',
                   fill_type='solid')

greenFill = PatternFill(start_color='00FF00',
                   end_color='00FF00',
                   fill_type='solid')

# Create a list of lists with features about the articles where werthervalue is 1
def getWertherArticles(list):
    werther_list = []
    for i in list:
        j = i[2]
        if j[0] == 1:
            werther_list.append(i)

    return werther_list

def calcColorValue(dailyfeature, werther):
    sen = (dailyfeature[0] + dailyfeature[1])/2
    if (sen > 50 and not werther):
        return 1
    elif ((werther) or (sen < 10)):
        return 3
    else: return 2

def createSheet(csv_file):
    feature_list = createFeatures.createFeatureList(csv_file)
    daily_feature = helpers.getDailySentimentOverview(feature_list)
    wertherArticles = getWertherArticles(feature_list)
    werther = not len(wertherArticles) == 0
    color_value = calcColorValue(daily_feature,werther)
    wb = openpyxl.Workbook()
    sheet = wb.active

    sheet.title = date

    sheet['A1'] = "Suicide Prevention information based on media published on "+date+" File: "+csv_file.title()
    sheet['A1'].font = Font(bold=True)

    sheet['A2'] = "Sentiment with dict"
    sheet['B2'] = daily_feature[0]

    sheet['A3'] = "Sentiment with BayesClassifier"
    sheet['B3'] = daily_feature[1]

    if color_value == 1:
        sheet['D3'].fill = greenFill
    elif color_value == 2:
        sheet['D3'].fill = yellowFill
    elif color_value == 3:
        sheet['D3'].fill = redFill

    if not len(wertherArticles) == 0:
        sheet['A5'] = "At least one article was found that contains the word suicide:"
        sheet['A6'] = "Medium"
        sheet['B6'] = "Title"
        sheet['C6'] = "Link"
        sheet['D6'] = "Sent1"
        sheet['E6'] = "Sent2"
        sheet['F6'] = "Papageno"

        sheet['A6'].font = Font(bold=True)
        sheet['B6'].font = Font(bold=True)
        sheet['C6'].font = Font(bold=True)
        sheet['D6'].font = Font(bold=True)
        sheet['E6'].font = Font(bold=True)
        sheet['F6'].font = Font(bold=True)

        count = len(wertherArticles)
        for a in wertherArticles:
            b = a[2]
            sheet['A'+str(6+count)] = a[3]
            sheet['B'+str(6+count)] = a[4]
            sheet['C'+str(6+count)] = a[5]
            sheet['D'+str(6+count)] = a[0]
            sheet['F'+str(6+count)] = b[1]
            if a[1] == 0:
                sheet['E' + str(6 + count)] = "negative"
            elif a[1] == 100:
                sheet['E' + str(6 + count)] = "positive"

            count -= 1

        wb.save("./Suicide_Prevention_Information_" + date + "_Werther.xlsx")
    else:
        wb.save("./Suicide_Prevention_Information_" + date + ".xlsx")
    #    wb.save("./" + directory +"Suicide_Prevention_Information_" + date + ".xlsx")
    return

createSheet(csv)



#def run():
#    args = get_commandline_arguments()
#    if not args:
#        sys.exit(os.EX_USAGE)
#    else:
#        #outlets_frame = import_outlets(args[2])
#
#        #clean_file(args[0], args[1], outlets_frame)
#        createSheet(args[0], args[1])


#if __name__ == "__main__":
#    run()