import pandas as pd

import helpers
import preprocessing
import sen1_w_dict

neg_words_file = './Sentiment/SentiWS_v1.8c_Negative.txt'
pos_words_file = './Sentiment/SentiWS_v1.8c_Positive.txt'

neg_df = pd.read_csv(neg_words_file, header=None, names=["1", "2","3","4","5","6","7","8","9"]).apply(lambda x: x.astype(str).str.lower())
pos_df = pd.read_csv(pos_words_file, header=None, names=["1", "2","3","4","5","6","7","8","9"]).apply(lambda x: x.astype(str).str.lower())

pos_list = pos_df.values.tolist()
neg_list = neg_df.values.tolist()

def normalize(x):
    y = ((x+100)/200)*100
    return y

def count_sentiment(text):
    sentiment = 0

    tokens = sen1_w_dict.getFilteredTokens(text)
    for t in tokens:
        for elem in neg_list:
            if t in elem:
                sentiment += float(elem[1])
        for elem2 in pos_list:
            if t in elem2:
                sentiment += float(elem2[1])
    if (len(tokens)>0):
        sentiment = normalize((sentiment/len(tokens))*100)

    return sentiment


def sentiment_extraction(elem):
    sentimentvalue = count_sentiment(elem[5])
    return sentimentvalue

