import glob
import os
from nltk.classify import NaiveBayesClassifier
import helpers
import sen2_w_Bayes

war_path = "./Sentiment/krieg_artikel/"
illness_path = "./Sentiment/krankheit_artikel/"
sport_path = "./Sentiment/sport_artikel/"

war_files = glob.glob(os.path.join(war_path, "*.txt"))
illness_files = glob.glob(os.path.join(illness_path, "*.txt"))
sport_files = glob.glob(os.path.join(sport_path, "*.txt"))

def topic_classification(elem):
    """
    topic_classification() uses a NaiveBayesClassifier to classify a text based on the
    training data
    :param elem: elem[5] = article text
    :return: sent_value: 0 = negative, 100 = positive
    """
    war_texts = sen2_w_Bayes.getWordList(war_files, "war")
    illness_texts = sen2_w_Bayes.getWordList(illness_files, "illness")
    sport_texts = sen2_w_Bayes.getWordList(sport_files, "sport")

    train_set = war_texts + illness_texts + sport_texts
    classifier = NaiveBayesClassifier.train(train_set)

    if isinstance(elem[5], str):
        words = sen2_w_Bayes.getDictionary(elem[5])
        topic = classifier.classify(words)

    return topic

###################  TEST   ########################
#
#csv = "./testfiles/website_downloads_cleaned_klein.csv"
#datalist = helpers.createDataframe(csv).values.tolist()
#test_elem = datalist[27]
#
#print(topic_classification(test_elem))
#print(test_elem[5])
####################################################

